from ..._common.const import EventDataComponentType as _EventDataComponentType
from .._req_builder._list import _list_dataitem_event
from ..._prismcomponent.datacomponent import _News
from ..._utils.validate_utils import _validate_args

__all__ = ['news', 'dataitems', 'news_dataitems']

@_validate_args
def _build_event(
    datacomponentclass,
    dataitemid: int,
    offset: int = 0,
    datetype: str = 'entereddate',
    package: str = 'CIQ Key Developments',
):
    return datacomponentclass(
        dataitemid=dataitemid,
        offset=offset,
        datetype=datetype,
        package=package,
    )


def news(*args, **kwargs):
    return _build_event(_News, *args, **kwargs)


def dataitems(*args, **kwargs):
    return _list_dataitem_event()


@_validate_args
def news_dataitems(search: str = None, package: str = 'CIQ Key Developments'):
    return _list_dataitem_event(_EventDataComponentType.NEWS, search, package)
