import json

from ..._common.config import *
from ..._common.const import *
from ..._utils import _validate_args, post


__all__ = ['get_securitymaster', 'get_securitymaster_advanced']


@_validate_args
def get_securitymaster(attribute: str, search: str):
    query = [{'attribute': attribute, 'search': search}]
    return post(URL_SM, None, query)

@_validate_args
def get_securitymaster_advanced(queries: list):
    for q in queries:
        assert set(q.keys()) - {'operator'} == {'attribute', 'search'}, 'Valid arguments are "attribute", "search", and "operator"'
    return post(URL_SM, None, queries)
